// SkyRacer v0.01
// By Malcolm Smith
// Level drawing engine by Scott Noveck

//Uncomment one of the following blocks when using the IDE.
//Keep them commented if compiling with compile.bat.
/*
#define USE_TI89
*/
/*
#define USE_TI92PLUS
#define USE_V200
*/

#define MIN_AMS 101
#define NO_EXIT_SUPPORT
#define OPTIMIZE_ROM_CALLS


#include "includes.h"


void _main(void)
{
	INT_HANDLER save_int_1, save_int_5;
	LCD_BUFFER lcd;
	
	memcpy(lcd,LCD_MEM,LCD_SIZE);
	randomize();
	DetectHardwareVersion();
	InitGlobals();
	if(!AllocateMemory()) return; //Memory is freed in case of error within function
	RedirectInterrupts();
  buildcoordtable();	
	GrayOn();
#ifndef USE_TI89	
	InitBackground();
#endif
	GenerateRandomLevel(LEVELCOUNT-1);
	ShowIntro(AT_BEGINNING);
while(1)
{	
	ShowInfo();
	if(_keytest(RR_ESC)) break;
	
	PickLevel();
  drawinitialplane();
	if(!FindSpawnPoint())
	{
	AllKeysReleased();
	FreeMemory();
	GrayOff();
	memcpy(LCD_MEM,lcd,LCD_SIZE);
	ST_helpMsg("Level needs spawn point.");
  SetIntVec(AUTO_INT_1, save_int_1);
	SetIntVec(AUTO_INT_5, save_int_5);
		return;
	}
	InitGameVars();
	ControlMainSpeed();			
	
	while (!(_keytest(RR_ESC) || endlev_quit || death_quit))
	{
		contrast();
	 	if(!ControlMainSpeed()) continue;
		if(!MoveMainBall()) continue;
		FastCopyScreen(track_light,light);
		FastCopyScreen(track_dark,dark);		
		DrawMainBall();		
		DrawLives();
		FastCopyScreen(light,GetPlane(LIGHT_PLANE));
		FastCopyScreen(dark,GetPlane(DARK_PLANE));
	}
	if(endlev_quit)
	{
		ShowIntro(AT_END);
	}
	if(death_quit)
	{
		ShowDeath();
	}
	while(_keytest(RR_ESC)) continue;
}	
	AllKeysReleased();
	FreeMemory();
	GrayOff();
	memcpy(LCD_MEM,lcd,LCD_SIZE);
  SetIntVec(AUTO_INT_1, save_int_1);
	SetIntVec(AUTO_INT_5, save_int_5);
}
